Rivet::Cmp< T > Class Template Reference

`#include <Cmp.hh>`

## Public Member Functions

| operator CmpState () const
| Automatically convert to an enum.
| operator int () const
| Automatically convert to an integer.
template<typename U >
const Cmp< T > & | operator|| (const Cmp< U > &c) const
| If this state is equivalent, set this state to the state of c.
Standard constructors etc.
| Cmp (const T &t1, const T &t2)
| The default constructor.
template<typename U >
| Cmp (const Cmp< U > &x)
| The copy constructor.
| ~Cmp ()
| The destructor is not virtual since this is not intended to be a base class.
template<typename U >
const Cmp< T > & | operator= (const Cmp< U > &x)
| The assignment operator.

## Detailed Description

### template<typename T>
class Rivet::Cmp< T >

Helper class when checking the ordering of two objects.

Cmp is a helper class to be used when checking the ordering of two objects. When implicitly converted to an integer the value will be negative if the two objects used in the constructor are ordered and positive if they are not. Zero will be returned if they are equal.

The main usage of the Cmp class is if several variables should be checked for ordering in which case several Cmp objects can be combined as follows: `cmp(a1, a2) || cmp(b1, b2) || cmp(c1, c2)` where cmp is a global function for easy creation of Cmp objects.

The documentation for this class was generated from the following files:

- include/Rivet/Cmp.fhh
- include/Rivet/Cmp.hh